/*
		Convolution or Recursion Equation
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _CONRECEQ_H_
#define _CONRECEQ_H_

/* Multiply and Accumulate
input or output
length of input or output
coef a or coef b
length of coef a or coef b
index in output */
float MulAcc(float xy[],
	unsigned short lxy,
	float ab[],
	unsigned short lab,
	unsigned short iy);

/* Convolution or Recursive Equation
calculate output signal from input signal using recursion coefficients
input signal
input signal length
a coefficients (weight of input signal)
a coefficients length
b coefficients (weight of output signal)
b coefficients length
output signal */
void ConRecEq(float x[],
	unsigned short xl,
	float a[],
	unsigned short al,
	float b[],
	unsigned short bl,
	float y[]);
	
/* Convolution or Recursive Equation for TI-89
pointer to lists of real numbers on estack 
two list=convoltion 
three lists=recursion equation */
void ConRecEqWrapper(CESI argptr);
	
#endif
