//   fft.h - declaration of class
//   of fast Fourier transform - FFT
//
//   The code is property of LIBROW
//   You can use it on your own
//   When utilizing credit LIBROW site
//   
//   The following modifications (c) 2015 Ralph Schenn
//   - port from C++ to C
//   - port to TI-89 pocket calculator

#include <args.h>
 
#ifndef _FFT_H_
#define _FFT_H_
 
//   FOURIER TRANSFORM FOR TI-89
//     argptr  - pointer to list of complex numbers on estack
//     inverse - inverse transform
void FFTWrapper(CESI argptr, 
	enum Bool inverse);
 
//   FOURIER TRANSFORM, INPLACE VERSION
//     Data  - both input data and output
//     N     - length of both input data and result
enum Bool FFT(_Complex float* Data, 
	const unsigned short N, 
	const enum Bool Inverse);
 
//   Rearrange function and its inplace version
void Rearrange(_Complex float* Data, 
	const unsigned short N);
 
//   FFT implementation
void Perform(_Complex float* Data, 
	const unsigned short N, 
	const enum Bool Inverse);
 
//   Scaling of inverse FFT result
void ScaleData(_Complex float* Data, 
	const unsigned short N);
 
#endif
