/*
		Fourier
		
    Copyright (C) 2013  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <alloc.h>
#include <math.h>

/* discete fourier transform of complex list 
dir == 1 for DFT 
dir == -1 for inverse DFT */
HANDLE DFT(_Complex float input[], 
	unsigned short length, 
	char dir) // ok
{
	_Complex float sum = 0;
	unsigned short j, k;
	
	HANDLE result = HeapAllocThrow (length * sizeof (_Complex float));
	_Complex float *resultPtr = HeapDeref (result);
	
	for (k = 0; k < length; k++) {
		for (j = 0; j < length; j++) {
			sum += exp (dir * 2.0i * PI * ((j * k) / length) ) * input[j];
		}
		
		resultPtr[k] = dir == 1 ? sum : 1 / length * sum;
		sum = 0;
	}
	
	return result;
}
