/*
		numeric functions
		
    Copyright (C) 2013  Ralph Schenn with support from Kevin Kofler

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <args.h>
#include <basop.h>
#include <error.h>
#include <estack.h>
#include <limits.h>
#include <math.h>
#include "Num.h"

/* check if number is a power of 2 */
enum Bool IsPow2(unsigned long int arg)
{
	return ((arg != 0) && !(arg & (arg - 1)));
}

/* absolute value of complex float */
float Cabs(_Complex float arg)
{
	return sqrt(__real__ arg * __real__ arg + __imag__ arg * __imag__ arg);
}

/*unsigned long Fact(unsigned short arg)
// factorial 
// what magnitude must the arg have for overflowing the long result
{
  // push argument to estack
  push_shortint (arg);
  
  // calculate factorial
  push_factorial (top_estack);
  
  // get result from estack
  long result = GetLongLongArg (top_estack);
  
  // remove result from estack
  delete_expression (top_estack);
  
  return result;
}*/

/* binary logarithm */
float Log2(float arg)
{
	return log(arg) / log(2);
}
