/*
		binary search
		
    Copyright (C) 2013  Ralph Schenn with support from Kevin Kofler

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <asmtypes.h>

#ifndef _SEARCH_H_
#define _SEARCH_H_

/* check if array of handles to strings contains string 
return -1 if string was not found 
when string is found the index is returned */
short ArrayContStr(HANDLE strArray[], short length, const char *str);

/* search memory subblock in block 
this works for arbitrary content without the need for \0 termination 
case sensitive search */ 
char *blockblock(const char *block, 
	const char *subBlock, 
  unsigned short blockLen, 
  unsigned short subBlockLen);
 
/* search memory block subblock in block 
this works for arbitrary content without the need for \0 string termination 
case insensitive search */ 
char *blockblockci(const char *block,
	const char *subBlock, 
  unsigned short blockLen, 
  unsigned short subBlockLen);

/* count number of occurences of val in array 
array must not be null-terminated */
unsigned short CountChar(char array[], unsigned short length, char val);

/* check if expr contains str
str must be null-terminated */
BOOL MultiExprContStr(MULTI_EXPR *expr, const char *str);

/* binary search a list of floats */
void SearchFloatList(CESI argptr);

#endif
