/*
		sorting functions
		
    Copyright (C) 2013  Ralph Schenn with support from Kevin Kofler

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _SORT_H_
#define _SORT_H_

/* sort order */
typedef enum order { ASC = 'a', DESC = 'd' } order;

/* sort list of complex floats */
void SortComplexFloatList(CESI argptr, order ord);

/* sort list of floats */
void SortFloatList(CESI argptr, order ord);

/* sort list of ints */
void SortLongList(CESI argptr, order ord);

/* sort list of strings */
void SortStringList(CESI argptr, order ord);

#endif
