/*
		receq - recursive equation
		Example: conreceq({1,2,3,4}, {1,2}) -> Convolution
		Example: conreceq({1,2,3,4}, {1,2}, {3,4}) -> Recursive Equation
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <args.h>
#include <error.h>
#include "Stack.h"
#include "ConRecEq.h"

#define MIN_NUM_ARGS 2
#define MAX_NUM_ARGS 3

// pass imaginary unit like this: cZeros(x^2+1,x)[2]
// pass -1 like this: zeros(x^2-1,x)[1]
void _main(void)
{	
	CESI argptr = top_estack;

	// check number of parameters
	CheckNumArgsInt (MIN_NUM_ARGS, MAX_NUM_ARGS);
				
	// get lists from estack
	// perform convolution or recursive equation
	// two lists=convolution
	// three lists=recursive equation
	// push result to estack				
	ConRecEqWrapper (argptr);
}
