/*
		movavg - moving average
		Example: movavg({1,2,3,4},2)
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <args.h>
#include <string.h>
#include <basfunc.h>
#include <error.h>
#include <math.h>
#include "Stack.h"
#include "MovAvg.h"

#define NUM_ARGS 2
#define LENGTH 1

// pass imaginary unit like this: cZeros(x^2+1,x)[2]
// pass -1 like this: zeros(x^2-1,x)[1]
void _main(void)
{	
	CESI argptr = top_estack;

	// check number of parameters
	CheckNumArgs (NUM_ARGS);
		
	// get second argument
	int length = GetSignIntArgPos (LENGTH);
	
	// check value of second argument
	if (length < 1) {
		ER_throw (ER_DOMAIN);
	}			
	
	// get list from estack
	// perform moving average
	// push result to estack				
	MovAvgWrapper (argptr, length);
}
