/* 
convertion between numeric tag values and strings
when first arg is string it is converted to numeric tag value
when first arg is numeric it is converted to string
the second argument allows choosing between basic ("b") and 
extended tag ("e") conversion

??? no possibility to correct the expression and press enter again
*/

//#define COMMENT_STRING "NUM|STR,\"b\"|\"e\""
#define COMMENT_STRING "TAG"

#include <string.h>
#include <args.h>
#include <error.h>
#include <estack.h>
#include "Stack.h"
#include "Tags.h"

// wrapper to make function available to basic functions
void _main(void)
{
	CESI ptr = top_estack;
	
	// check number of arguments
	CheckNumArgs (2);
	
	// type of first parameter
	unsigned char t1 = GetArgNumType (0);
	
	// type of second parameter
	unsigned char t2 = GetArgNumType (1);
			
	// type of first or second argument is invalid
	if ((t1 != POSINT_TAG && t1 != STR_TAG) || t2 != STR_TAG) { 
		ER_throw (ER_DATATYPE);
	}

	// tag as int
	enum Tags c = 0;
	
	// tag as string
	const char *s;
	
	// basic or extended tag
	const char *e;
	
	switch (t1) {
		// arg is numeric - convert to string
		case POSINT_TAG:
		// get first parameter
		c = GetIntArg (ptr);
		
		// get second parameter
		e = GetStrnArg (ptr);
		
		CleanStack ();

		// basic tag conversion
		if (strcmp(e, "b") == 0) {
			// convert tag to string
			s = Tag2Str (c);
		// extended tag conversion
		} else if (strcmp(e, "e") == 0) {
			// convert extended tag to string
			s = ExtTag2Str (c);
		// second argument contains invalid value	
		} else {
			ER_throw (ER_ARGUMENT);
		}

		// push string on estack
		push_ANSI_string (s);
		
		break;
	// arg is string - convert to numeric
	case STR_TAG:
		// get first parameter
		s = GetStrnArg (ptr);
		
		// get second parameter
		e = GetStrnArg (ptr);

		CleanStack ();
		
		// basic tag conversion
		if (strcmp(e, "b") == 0) { 			
			// convert string to numeric
			c = Str2Tag (s);
			// extended tag conversion
		} else if (strcmp(e, "e") == 0) {
			// convert extended tag to string
			c = Str2ExtTag (s);
		// second argument contains invalid value	
		} else {
			ER_throw (ER_ARGUMENT);
		}
		
		// push numeric value on estack
		push_shortint (c);
			
		break;
	}
	
}
