/*
		pop and push complex list of floats
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <alloc.h>
#include <args.h>
#include <basfunc.h>
#include <error.h>
#include <float.h>
#include "Stack.h"

#define NUM_ARGS 1

// pass imaginary unit like this: cZeros(x^2+1,x)[2]
// pass -1 like this: zeros(x^2-1,x)[1]
void _main(void)
{	
	CESI argptr = top_estack;

	// check number of parameters
	CheckNumArgs (NUM_ARGS);
		
	HANDLE xHdl = H_NULL;

	TRY	
		// read list into array
		unsigned short lenX = GetComplexFloatListArg (&argptr, &xHdl);
				
		CleanStack ();
						
		_Complex float *xPtr = NULL;
		
		// list is not empty
		if (xHdl != H_NULL)
		{
			xPtr = HeapDeref (xHdl);
		}
				  			
		// push list in reverse order to estack
		// when passing empty list xHdl == H_NULL and lenX == 0
		push_complex_float_list (xPtr, lenX);			
	FINALLY
		// avoid address error when arg is empty list
		if (xHdl != H_NULL)
		{
			HeapFree (xHdl);
		}
	ENDFINAL
}
